package MuGeN::ColorHandler;

use strict;

sub _new {
    my $class=shift;
    my $name=shift;
    my $self={};

    bless $self,$class;

    $self->{name}=$name;

    return $self;
}

sub name {
    my $self=shift;

    return $self->{name};
}

%MuGeN::ColorHandler::color_scheme=();

sub get_colors_for {
    my $self=shift;
    my $feature=shift;
    
    my $name=lc $feature->primary_tag();

    my ($color,$filled)=('black',0);
    if (defined $MuGeN::ColorHandler::color_scheme{$name}) {
	($color,$filled)=&{$MuGeN::ColorHandler::color_scheme{$name}}($self,$feature);
    }
    return ($color,$filled);
}

package MuGeN::ColorHandlerFactory;

use strict;

BEGIN {

    %MuGeN::ColorHandlerFactory::Factory=();
    my @modules=qw(DefaultColorHandler ECColorHandler FileColorHandler);

    foreach my $module (@modules) {
	eval {
	    require "MuGeN/ColorHandler/$module.pm";
	}
    }
}


1
