package MuGeN::ColorHandler::ECColorHandler;

use strict;

use MuGeN::ColorHandler::DefaultColorHandler;
use MuGeN::PaintDevice;

@MuGeN::ColorHandler::ECColorHandler::ISA=qw(MuGeN::ColorHandler::DefaultColorHandler);

%MuGeN::ColorHandler::ECColorHandler::color_scheme=%MuGeN::ColorHandler::DefaultColorHandler::color_scheme;

@MuGeN::ColorHandler::ECColorHandler::ECColors=qw(black red green blue cyan magenta yellow);

BEGIN {
    $MuGeN::ColorHandlerFactory::Factory{'EC number based'}=sub { return new MuGeN::ColorHandler::ECColorHandler @_};

}

sub new {
    my $class=shift;
    my $name=shift;
    $name='EC number based'
	unless defined $name;

    my $self=new MuGeN::ColorHandler::DefaultColorHandler($name);

    bless $self,$class;

    return $self;
}

sub get_colors_for_cds {
    my $self=shift;
    my $feature=shift;

    my $filled=0;
    my $color='black';
    my $has_ec=$feature->has_tag('EC_number');
    if ($has_ec) {
	$filled=1;
	my ($ecnumber,@dummy)=$feature->each_tag_value('EC_number');
	my (@digits)=split /\./,$ecnumber;
	$color=$MuGeN::ColorHandler::ECColorHandler::ECColors[$digits[0]]
	    if (defined $MuGeN::ColorHandler::ECColorHandler::ECColors[$digits[0]]);
    }
    return ($color,$filled);
}

$MuGeN::ColorHandler::ECColorHandler::color_scheme{'cds'}=sub { get_colors_for_cds @_ };

sub get_colors_for {
    my $self=shift;
    my $feature=shift;

    %MuGeN::ColorHandler::color_scheme=%MuGeN::ColorHandler::ECColorHandler::color_scheme;
    
    return $self->MuGeN::ColorHandler::get_colors_for($feature);
}


1
