package MuGeN::CompAnalResultSourceWindow::CumulatedGCSkewWindow;

use strict;

use MuGeN::CompAnalResultSourceWindow;

@MuGeN::CompAnalResultSourceWindow::CumulatedGCSkewWindow::ISA=qw(Gtk2::Dialog MuGeN::CompAnalResultSourceWindow);

sub new {
    my $class=shift;
    my $manager=shift;

    my $self=new Gtk2::Dialog();

    $self->{manager}=$manager;

    $self->set_title("GC Skew");

    my $dialogvbox=$self->vbox();

    my $vbox=new Gtk2::VBox();
    $vbox->show();
    $dialogvbox->pack_start($vbox,1,1,0);
    
    my $hbox=new Gtk2::HBox();
    $hbox->show();
    $vbox->pack_start($hbox,1,1,0);

    
    my $label=new Gtk2::Label("Window size");
    $label->show();
    $hbox->pack_start($label,1,1,0);

    my $entry=new Gtk2::Entry();
    $entry->show();
    $hbox->pack_start($entry,1,1,0);
    $self->{windowsizeentry}=$entry;

    $hbox=new Gtk2::HBox();
    $hbox->show();
    $vbox->pack_start($hbox,1,1,0);

    
    $label=new Gtk2::Label("Endpoint");
    $label->show();
    $hbox->pack_start($label,1,1,0);

    my $entry=Gtk2::Entry->new_with_max_length(9);
    $entry->set_text("10000");
    $entry->show();
    $hbox->pack_start($entry,1,1,0);
    $self->{endentry}=$entry;

    
    my $action_area=$self->action_area();

    my $btn=new Gtk2::Button("OK");
    $btn->signal_connect('clicked',sub {$self->hide(); $self->ok_clicked();});
    $btn->show();
    $action_area->pack_start($btn,1,1,0);

    $btn=new Gtk2::Button("Cancel");
    $btn->signal_connect('clicked',sub {$self->hide(); return 1;});
    $btn->show();
    $action_area->pack_start($btn,1,1,0);

    bless $self,$class;

    return $self;
}

sub ok_clicked {
    my $self=shift;

    my $windowsize=$self->{windowsizeentry}->get_text();
    my $end=$self->{endentry}->get_text();

    my $mapinfo=$self->{manager}->get_mapinfo('NAME' => $self->{mapname});
    if (defined $mapinfo) {
	my $seqobj=$mapinfo->get_map()->get_seqobj();
	my $source=new MuGeN::CompAnalResultSource::CumulatedGCSkewSource($seqobj,
								   $windowsize,
								   $end,
								   $self->{mapname});

	$self->{manager}->add_results_from_source($self->{mapname},$source);
    }
    return 1;
}
